> ## Documentation Index
> Fetch the complete documentation index at: https://docs.tight.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Save invoice item templates

> Save new (or update existing) invoice item templates



## OpenAPI

````yaml https://dev.tight.com/v3/api-docs post /v6/invoicing/itemTemplates
openapi: 3.0.1
info:
  title: Tight API
  contact:
    name: Hurdlr, Inc. (dba Tight)
    url: https://www.tight.com
    email: api@tight.com
  version: 6.0.0
servers:
  - url: https://sandbox.tight.com
    description: Staging Environment
  - url: https://prod.tight.com
    description: Production Environment
security:
  - EmbedToken: []
paths:
  /v6/invoicing/itemTemplates:
    post:
      tags:
        - Invoicing - Item Templates
      summary: Save invoice item templates
      description: Save new (or update existing) invoice item templates
      operationId: postItemTemplates
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/MultiParamInvoiceItemTemplatePostDto'
        required: true
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/ResponseListMultiResponseInvoiceItemTemplateGetDto
        '207':
          description: >-
            Some item templates failed to save. See response body for error
            details.
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/ResponseListMultiResponseInvoiceItemTemplateGetDto
        '400':
          description: All item templates failed to save.
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/ResponseListMultiResponseInvoiceItemTemplateGetDto
        '401':
          description: Not authenticated
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                result: FAILURE
                error:
                  - type: INVALID_TOKEN
                    message: Invalid access token
        '403':
          description: Not authorized
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                result: FAILURE
                error:
                  - type: FORBIDDEN
                    message: Expired access token
        '404':
          description: Endpoint not found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                result: FAILURE
                error:
                  - type: BAD_REQUEST
                    message: Resource not found
        '500':
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                result: FAILURE
                error:
                  - type: UNKNOWN_ERROR
                    message: Something went wrong. Please try again later.
      security:
        - EmbedToken: []
components:
  schemas:
    MultiParamInvoiceItemTemplatePostDto:
      required:
        - data
      type: object
      properties:
        data:
          type: array
          items:
            $ref: '#/components/schemas/InvoiceItemTemplatePostDto'
    ResponseListMultiResponseInvoiceItemTemplateGetDto:
      type: object
      properties:
        result:
          type: string
          description: The result of the action performed.
          enum:
            - SUCCESS
            - FAILURE
        data:
          type: array
          description: The data generated by the action performed.
          items:
            $ref: '#/components/schemas/MultiResponseInvoiceItemTemplateGetDto'
        error:
          type: array
          items:
            $ref: '#/components/schemas/ErrorItem'
    ErrorResponse:
      type: object
      properties:
        result:
          type: string
          description: The result of the action performed.
          enum:
            - SUCCESS
            - FAILURE
        data:
          type: object
          description: The data generated by the action performed.
          nullable: true
        error:
          type: array
          items:
            $ref: '#/components/schemas/ErrorItem'
    InvoiceItemTemplatePostDto:
      required:
        - name
      type: object
      properties:
        id:
          type: string
          description: >-
            Id of the invoice item template, required when updating an existing
            template
          example: tili_28868401
        name:
          type: string
          description: Name of the invoice item template
          nullable: false
          example: Standard Service Fee
        status:
          type: string
          description: Status of the invoice item template
          nullable: false
          example: ACTIVE
          enum:
            - ACTIVE
            - INACTIVE
            - REMOVED
        description:
          type: string
          description: Description of the invoice item template
          nullable: false
          example: Standard hourly service fee
        amount:
          type: integer
          description: Amount of the invoice item template in cents
          format: int32
          nullable: false
          example: 5000
        quantity:
          type: string
          description: Quantity of the invoice item template
          nullable: false
          example: '1.0'
        price:
          type: string
          description: Price of the invoice item template
          nullable: false
          example: '50.0'
        salesTax:
          $ref: '#/components/schemas/SalesTaxPostDto'
        glAccountId:
          type: string
          description: Id of the GL account to associate with the invoice item template
          nullable: false
          example: gla_28868401
        customData:
          $ref: '#/components/schemas/JsonNode'
    MultiResponseInvoiceItemTemplateGetDto:
      type: object
      properties:
        result:
          type: string
          description: The result of the action performed.
          enum:
            - SUCCESS
            - FAILURE
        statusCode:
          $ref: '#/components/schemas/HttpStatus'
        data:
          $ref: '#/components/schemas/InvoiceItemTemplateGetDto'
        error:
          type: array
          items:
            $ref: '#/components/schemas/ErrorItem'
      description: The data generated by the action performed.
    ErrorItem:
      type: object
      properties:
        type:
          type: string
          description: The type of the error. Safe for programmatic use.
          enum:
            - UNKNOWN_ERROR
            - INVALID_TOKEN
            - EXPIRED_TOKEN
            - FORBIDDEN
            - BAD_REQUEST
            - JSON_ERROR
            - DUPLICATE
            - REQUIRED
            - INVALID_VALUE
            - NOT_MODIFIABLE
            - INVALID_FORMAT
            - NOT_FOUND
        message:
          type: string
          description: >-
            A human-readable message providing more details about the error.
            Safe for displaying to a user.
        param:
          type: string
          description: >-
            If the error is parameter-specific, the parameter related to the
            error. This can be used to display a message near the correct form
            field.
      description: Errors associated with the action performed, if applicable.
    SalesTaxPostDto:
      type: object
      properties:
        value:
          type: string
          description: The sales tax value
          example: '8.875'
        type:
          type: string
          description: The type of the sales tax value
          example: PERCENT
          enum:
            - AMOUNT
            - PERCENT
      description: Sales tax applied to the invoice item template
      nullable: false
    JsonNode:
      type: object
      properties:
        empty:
          type: boolean
        array:
          type: boolean
        'null':
          type: boolean
        object:
          type: boolean
        float:
          type: boolean
        string:
          type: boolean
        number:
          type: boolean
        missingNode:
          type: boolean
        valueNode:
          type: boolean
        nodeType:
          type: string
          enum:
            - ARRAY
            - BINARY
            - BOOLEAN
            - MISSING
            - 'NULL'
            - NUMBER
            - OBJECT
            - POJO
            - STRING
        pojo:
          type: boolean
        integralNumber:
          type: boolean
        floatingPointNumber:
          type: boolean
        short:
          type: boolean
        int:
          type: boolean
        long:
          type: boolean
        double:
          type: boolean
        bigDecimal:
          type: boolean
        bigInteger:
          type: boolean
        textual:
          type: boolean
          deprecated: true
        boolean:
          type: boolean
        binary:
          type: boolean
        container:
          type: boolean
        embeddedValue:
          type: boolean
      description: >-
        Custom JSON in which you can store any data with max length of 2000
        characters
      nullable: true
      example:
        internal_key: some_internal_key
        some_other_field: 23434
    HttpStatus:
      type: integer
      description: The HTTP status code for the action performed.
      format: int32
      enum:
        - 200
        - 400
        - 401
        - 403
        - 404
        - 500
    InvoiceItemTemplateGetDto:
      required:
        - amount
        - description
        - glAccount
        - id
        - name
        - price
        - quantity
        - salesTax
        - status
      type: object
      properties:
        id:
          type: string
          description: Id of the invoice item template
          example: tili_28868401
        name:
          type: string
          description: Name of the invoice item template
          example: Standard Service Fee
        status:
          type: string
          description: Status of the invoice item template
          example: ACTIVE
          enum:
            - ACTIVE
            - INACTIVE
            - REMOVED
        description:
          type: string
          description: Description of the invoice item template
          nullable: true
          example: Standard hourly service fee
        amount:
          type: integer
          description: Amount of the invoice item template in cents
          format: int32
          nullable: true
          example: 5000
        quantity:
          type: string
          description: Quantity of the invoice item template
          nullable: true
          example: '1.0'
        price:
          type: string
          description: Price of the invoice item template
          nullable: true
          example: '50.0'
        salesTax:
          $ref: '#/components/schemas/SalesTax'
        glAccount:
          $ref: '#/components/schemas/ApiGetExpandable'
        customData:
          $ref: '#/components/schemas/JsonNode'
      description: The data generated by the action performed.
    SalesTax:
      required:
        - type
        - value
      type: object
      properties:
        value:
          type: string
          description: The sales tax value
          example: '8.875'
        type:
          type: string
          description: The type of the sales tax value
          example: PERCENT
          enum:
            - AMOUNT
            - PERCENT
      description: Sales tax applied to the invoice item template
      nullable: true
    ApiGetExpandable:
      type: object
      description: GL account associated with the invoice item template
      nullable: true
  securitySchemes:
    EmbedToken:
      type: http
      description: >-
        Bearer authentication header of the form `Bearer <token>`, see
        [Authentication for more
        detail](/api-reference/authentication#partner-level-authentication).
      scheme: bearer

````